
/*MA****************************************************************/
/*                                                                 */
/*     File: tree.h                                                */
/*   Author: Helmut Schmid                                         */
/*  Purpose:                                                       */
/*  Created: Tue Jan 21 13:27:46 2003                              */
/* Modified: Fri Nov 13 08:23:35 2009 (schmid)                     */
/*                                                                 */
/*ME****************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <vector>
using std::vector;

extern bool Verbose;
extern bool PrettyPrint;
extern int  Trace_Number;

extern FILE *outfile;

class Tree;

typedef vector<Tree*> Trees;


/*****************  class Tree  ************************************/

class Tree {

private:
  char *slash_cat( char *c );
  char *find_trace( char*, char, bool& );
  void add_trace_feature( char c );
  void add_markup( const char *s, char d );

  bool delete_slashes_down( char *sc, char d );
  bool delete_slashes_up( char *sc, char d );
  bool convert( bool& );

  void print_subtree(int);
  void print();

  void undo_markov();

public:
  char  *label;
  Tree  *mother;
  Trees daughters;

  Tree( char *l ) { label = l; mother = NULL; };

  Tree( char *l, Trees *d ) { 
    label = l;
    daughters = *d;
    for( size_t i=0; i<daughters.size(); i++ )
      daughters[i]->mother = this;
    mother = NULL; 
  };

  ~Tree() {
    free(label);
    for( size_t i=0; i<daughters.size(); i++ )
      delete daughters[i];
  }

  void process();
};
